
# libreoffice

This is the libreoffice module. It allows to install libreoffice core and to start it in listen mode as a service.






#### Table of Contents

1. [Description](#description)
2. [Setup - The basics of getting started with libreoffice](#setup)
    * [What libreoffice affects](#what-libreoffice-affects)
    * [Setup requirements](#setup-requirements)
    * [Beginning with libreoffice](#beginning-with-libreoffice)
3. [Usage - Configuration options and additional functionality](#usage)
4. [Reference - An under-the-hood peek at what the module is doing and how](#reference)
5. [Limitations - OS compatibility, etc.](#limitations)
6. [Development - Guide for contributing to the module](#development)

## Description

This is the libreoffice module. It allows to install libreoffice core and to start it in listen mode as a service.

The service will be listening for connections on port 8140 and allows to produce documents by using the UNO/URE APIs.

## Setup

### What libreoffice affects

This module installs the specified LibreOffice version from DEB files.

LibreOffice will be installed under /opt/libreoffice<MajVer><MinVer> and a link /opt/libreoffice will be created pointing to that folder.

An init script is deployed for starting LibreOffice as a service in listening mode.

A file with the locale environment variables configured for the specified locale is deploy under /etc/default and sourced from the init script.

LibreOffice minor versions substitute each other while packages of different major versions coexist. The module, however, does not remove LibreOffice packages; if desired, the packages related to a previous LibreOffice version could be removed by hand; for example to remove LibreOffice 4 packages issue the command:
```
sudo apt-get remove libreoffice4.*
```

### Setup Requirements

This module requires the `download_uncompress` module.

### Beginning with libreoffice

To use the module simply declare the class and specify LibreOffice version and locale to be used:
```
class {'libreoffice':
     majorver => '5',
     minorver => '4',
     incr     => '6',
     subincr  => '2',
     locale   => 'it_IT',
}
```

## Usage

The parameters of the class allow to specify the LibreOffice version. It is characterized by three numbers: major, minor, increment. A fourth number (subincrement) need also to be provided: it should be specified according to the fourth number visibile as folder name after uncompressing the distribution file.

## Reference

The documentation can be generated by puppet-strings in the doc folder of the module by issuing the command:
```
puppet strings
```
inside the module directory.

See: https://puppet.com/blog/using-puppet-strings-generate-great-documentation-puppet-modules

## Limitations

The module is developed and tested on Debian/Ubuntu OS platforms.

## Development

If you need some feature please send me a (pull) request and send me an email at: dsestero 'at' gmail 'dot' com.

